﻿create sequence sec_idUsuariRegistrat
  start 1
  minvalue 1
  maxvalue 999999
  increment by 1;

create sequence sec_idTorneig
  start 1
  minvalue 1
  maxvalue 999999
  increment by 1;

create sequence sec_idNotificacioTorneig
  start 1
  minvalue 1
  maxvalue 999999
  increment by 1;

create sequence sec_idCombat
  start 1
  minvalue 1
  maxvalue 999999
  increment by 1;

create sequence sec_idNotificacioCombat
  start 1
  minvalue 1
  maxvalue 999999
  increment by 1;

create sequence sec_idCurs
  start 1
  minvalue 1
  maxvalue 999999
  increment by 1;

create sequence sec_idNotificacioCurs
  start 1
  minvalue 1
  maxvalue 999999
  increment by 1;

create table Perfil(
  idPerfil integer not null,
  mant_torneos bit not null,
  busc_torneos bit not null,
  crear_torneos bit not null,
  mod_torneos bit not null,
  asig_luchadores bit not null,
  eli_torneos bit not null,
  sol_torneos bit not null,
  ab_torneos bit not null,
  opi_torneos bit not null,
  mant_combates bit not null,
  busc_combates bit not null,
  crear_combates bit not null,
  mod_combates bit not null,
  eli_combates bit not null,
  opi_comabates bit not null,
  mant_cursos bit not null,
  busc_cursos bit not null,
  crear_cursos bit not null,
  asig_participantes bit not null,
  mod_cursos bit not null,
  eli_cursos bit not null,
  sol_cursos bit not null,
  opi_cursos bit not null,
  mant_gimnasios bit not null,
  busc_gimnasios bit not null,
  mant_luchadores bit not null,
  busc_luchadores bit not null,
  mant_usuario bit not null,
  mod_usuario bit not null,
  baja_usuario bit not null,
  hist_usuario bit not null,
  mant_notificaciones bit not null,
  leer_notificaciones_torneos bit not null,
  leer_notificaciones_cursos bit not null,
  descripcion character varying(15) not null,
  constraint pk_perfil primary key (idPerfil)
);

create table UsuariRegistrat(
  idUsuari integer default nextval('sec_idUsuariRegistrat'),
  estat bool not null,
  username varchar(10) not null unique,
  password varchar(10) not null,
  idPerfil integer not null,
  constraint pk_usuariRegistrat primary key (idUsuari),
  constraint fk_usuari_perfil foreign key (idPerfil) references Perfil(idPerfil)  
);

create table Organitzador(
  idOrganitzador integer not null,
  nomOrg varchar(50) not null unique,
  cifOrg char(9) not null unique,
  adresaOrg varchar(35) not null,
  poblacioOrg varchar(30) not null,
  cpOrg char(5) not null,
  provinciaOrg varchar(20) not null,
  telefonoOrg char(9) not null,
  emailOrg varchar(80),
  webOrg varchar(80),
  constraint pk_organitzador primary key (idOrganitzador),
  constraint fk_org_usuariRegistrat foreign key (idOrganitzador) references UsuariRegistrat(idUsuari)
);

create table Esportista(
  idEsportista integer not null,
  nomLlui varchar(15) not null,
  cognom1Llui varchar(15) not null,
  cognom2Llui varchar(15),
  anyNaixementLlui char(4) not null,
  pesLlui integer not null,
  constraint pk_esportista primary key (idEsportista),
  constraint fk_esp_usuariRegistrat foreign key (idEsportista) references UsuariRegistrat(idUsuari)
);

create table Gimnas(
  idGimnas integer not null,
  nomGim varchar(50) not null unique,
  cifGim char(9) not null unique,
  adresaGim varchar(35) not null,
  poblacioGim varchar(30) not null,
  cpGim char(5) not null,
  provinciaGim varchar(20) not null,
  telefonGim char(9) not null,
  emailGim varchar(80),
  webGim varchar(80),
  horaAberturaGim char(5) not null,
  horaTancamentGim char(5) not null,
  dissabtesGim bool not null,
  metresTatami integer not null,
  ring bool not null,
  gabia bool not null,
  constraint pk_gimnas primary key (idGimnas),
  constraint fk_gim_usuariRegistrat foreign key (idGimnas) references UsuariRegistrat(idUsuari)
);

create table Estat(
  idEstat integer not null,
  nomEstat varchar(35) not null unique,
  constraint pk_estat primary key (idEstat)
);

create table Torneig(
  idTorneig integer default nextval('sec_idTorneig'),
  idOrganitzador integer not null,
  adresaTor varchar(35) not null,
  poblacioTor varchar(30) not null,
  cpTor char(5) not null,
  provinciaTor varchar(20) not null,
  dataInici character(10) not null,
  dataFi character(10) not null,
  premiTorneig varchar(50) not null,
  constraint pk_torneig primary key (idTorneig),
  constraint fk_torneig_organitzador foreign key (idOrganitzador) references Organitzador (idOrganitzador)
);

create table NotificacioTorneig(
  idNotificacioTorneig integer default nextval('sec_idNotificacioTorneig'),
  idEsportista integer not null,
  idOrganitzador integer not null,
  idTorneig integer not null,
  missatge text,
  estat integer not null,
  constraint pk_notTorneig primary key (idNotificacioTorneig),
  constraint fk_notTorneig_esportista foreign key (idEsportista) references Esportista (idEsportista),
  constraint fk_notTorneig_organitzador foreign key (idOrganitzador) references Organitzador (idOrganitzador),
  constraint fk_notTorneig_torneig foreign key (idTorneig) references Torneig (idTorneig),
  constraint fk_notTorneig_estat foreign key (estat) references Estat (idEstat)
);

create table Combat(
  idCombat integer default nextval('sec_idCombat'),
  idTorneig integer not null,
  dataComb char(10) not null,
  hora char(5) not null,
  pesComb varchar(12) not null,
  nomllui1 varchar(47) not null,
  nomllui2 varchar(47) not null,
  constraint pk_combat primary key (idCombat),
  constraint fk_combat_torneig foreign key (idTorneig) references Torneig (idTorneig)
);

create table NotificacioCombat(
  idNotificacioCombat integer default nextval('sec_idNotificacioCombat'),
  idEsportista integer not null,
  idOrganitzador integer not null,
  idCombat integer not null,
  missatge text,
  estat integer not null,
  constraint pk_notCombat primary key (idNotificacioCombat),
  constraint fk_notCombat_esportista foreign key (idEsportista) references Esportista (idEsportista),
  constraint fk_notCombat_organitzador foreign key (idOrganitzador) references Organitzador (idOrganitzador),
  constraint fk_notCombat_combat foreign key (idCombat) references Combat (idCombat),
  constraint fk_notCombat_estat foreign key (estat) references Estat (idEstat)
);

create table Curs(
  idCurs integer default nextval('sec_idCurs'),
  idGimnas integer not null,
  adresaCurs varchar(35) not null,
  poblacioCurs varchar(30) not null,
  cpCurs char(5) not null,
  provinciaCurs varchar(20),
  dataIniciCurs char(10) not null,
  dataFiCurs char(10) not null,
  horariCurs varchar(100) not null,
  modalitatCurs varchar(50) not null,
  mestreCurs varchar(100) not null,
  preuCurs integer not null,
  constraint pk_curs primary key (idCurs),
  constraint fk_curs_gimnas foreign key (idGimnas) references Gimnas (idGimnas)
);

create table NotificacioCurs(
  idNotificacioCurs integer default nextval('sec_idNotificacioCurs'),
  idEsportista integer not null,
  idGimnas integer not null,
  idCurs integer not null,
  missatge text,
  estat integer not null,
  constraint pk_notCurs primary key (idNotificacioCurs),
  constraint fk_notCurs_esportista foreign key (idEsportista) references Esportista (idEsportista),
  constraint fk_notCurs_gimnas foreign key (idGimnas) references Gimnas (idGimnas),
  constraint fk_notCurs_curs foreign key (idCurs) references Curs (idCurs),
  constraint fk_notCurs_estat foreign key (estat) references Estat (idEstat)
);
